"use strict";
exports.__esModule = true;
var getScrollParent_1 = require("./getScrollParent");
var getOffsetParent_1 = require("./getOffsetParent");
var getParentNode_1 = require("./getParentNode");
var getWindow_1 = require("./getWindow"); // A "clipping parent" is a scrolling container with the characteristic of
// clipping (or hiding) overflowing elements with a position different from `initial`
function getClippingParent(element) {
    var scrollParent = getScrollParent_1["default"](element);
    var offsetParent = getOffsetParent_1["default"](element);
    var win = getWindow_1["default"](element);
    return offsetParent === win ? element.ownerDocument.documentElement : scrollParent.contains(offsetParent) ? scrollParent : getClippingParent(getScrollParent_1["default"](getParentNode_1["default"](scrollParent)));
}
exports["default"] = getClippingParent;
