"use strict";
exports.__esModule = true;
var getParentNode_1 = require("./getParentNode");
var getComputedStyle_1 = require("./getComputedStyle");
function getScrollParent(node) {
    if (!node) {
        return document.body;
    }
    if (['HTML', 'BODY', '#document'].includes(node.nodeName.toUpperCase())) {
        return node.ownerDocument.body;
    }
    if (node instanceof HTMLElement) {
        // Firefox want us to check `-x` and `-y` variations as well
        var _a = getComputedStyle_1["default"](node), overflow = _a.overflow, overflowX = _a.overflowX, overflowY = _a.overflowY;
        if (/(auto|scroll|overlay)/.test(overflow + overflowY + overflowX)) {
            return node;
        }
    }
    return getScrollParent(getParentNode_1["default"](node));
}
exports["default"] = getScrollParent;
