"use strict";
exports.__esModule = true;
// This modifier takes the styles prepared by the `computeStyles` modifier
// and applies them to the HTMLElements such as popper and arrow
function applyStyles(state) {
    Object.keys(state.elements).forEach(function (name) {
        var style = state.styles.hasOwnProperty(name) ? state.styles[name] : null; // Flow doesn't support to extend this property, but it's the most
        // effective way to apply styles to an HTMLElemen
        // $FlowIgnore
        Object.assign(state.elements[name].style, style);
    });
    return state;
}
exports.applyStyles = applyStyles;
exports["default"] = {
    name: 'applyStyles',
    enabled: true,
    phase: 'write',
    fn: applyStyles,
    requires: ['computeStyles']
};
