"use strict";
exports.__esModule = true;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
        symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; });
    keys.push.apply(keys, symbols);
} return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
        ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); });
    }
    else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    }
    else {
        ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); });
    }
} return target; }
function _defineProperty(obj, key, value) { if (key in obj) {
    Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
}
else {
    obj[key] = value;
} return obj; }
var getBoundingClientRect_1 = require("../dom-utils/getBoundingClientRect");
var getClippingParent_1 = require("../dom-utils/getClippingParent");
var getDocumentRect_1 = require("../dom-utils/getDocumentRect");
var computeOffsets_1 = require("../utils/computeOffsets");
var rectToClientRect_1 = require("../utils/rectToClientRect");
function detectOverflow(state, options) {
    if (options === void 0) { options = {
        boundaryElement: getClippingParent_1["default"](state.elements.popper)
    }; }
    var popperElement = state.elements.popper;
    var referenceElement = state.elements.reference;
    var popperRect = state.measures.popper;
    var documentElement = options.boundaryElement.ownerDocument.documentElement;
    if (!options.boundaryElement.contains(popperElement)) {
        console.error('PopperJS: "detectOverflow" can accept as `boundaryElement` only a parent node of the provided popper.');
        return state;
    }
    var boundaryClientRect = documentElement === options.boundaryElement ? rectToClientRect_1["default"](getDocumentRect_1["default"](documentElement)) : getBoundingClientRect_1["default"](options.boundaryElement);
    var referenceClientRect = getBoundingClientRect_1["default"](referenceElement);
    var popperOffsets = computeOffsets_1["default"]({
        reference: referenceClientRect,
        element: popperRect,
        strategy: 'absolute',
        placement: state.options.placement,
        scroll: {
            scrollTop: 0,
            scrollLeft: 0
        }
    });
    var popperClientRect = rectToClientRect_1["default"](_objectSpread({}, popperRect, {}, popperOffsets));
    state.modifiersData.detectOverflow = {
        top: boundaryClientRect.top - popperClientRect.top,
        bottom: popperClientRect.bottom - boundaryClientRect.bottom,
        left: boundaryClientRect.left - popperClientRect.left,
        right: popperClientRect.right - boundaryClientRect.right
    };
    return state;
}
exports.detectOverflow = detectOverflow;
exports["default"] = {
    name: 'detectOverflow',
    enabled: true,
    phase: 'read',
    fn: detectOverflow,
    data: {}
};
