"use strict";
exports.__esModule = true;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
        symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; });
    keys.push.apply(keys, symbols);
} return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
        ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); });
    }
    else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    }
    else {
        ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); });
    }
} return target; }
function _defineProperty(obj, key, value) { if (key in obj) {
    Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
}
else {
    obj[key] = value;
} return obj; }
var getOppositePlacement_1 = require("../utils/getOppositePlacement");
var getBasePlacement_1 = require("../utils/getBasePlacement");
function flip(state, options) {
    var placement = state.placement;
    var behavior = options && options.behavior ? options.behavior : [state.options.placement, getOppositePlacement_1["default"](placement)];
    var overflow = state.modifiersData.detectOverflow;
    var flippedPlacement = behavior.find(function (newPlacement) { return overflow[getBasePlacement_1["default"](newPlacement)] <= 0; });
    if (flippedPlacement && flippedPlacement !== placement) {
        state = _objectSpread({}, state, {
            placement: flippedPlacement,
            reset: true
        });
    }
    return state;
}
exports.flip = flip;
exports["default"] = {
    name: 'flip',
    enabled: true,
    phase: 'main',
    fn: flip
};
