"use strict";
exports.__esModule = true;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly)
        symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; });
    keys.push.apply(keys, symbols);
} return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
        ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); });
    }
    else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    }
    else {
        ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); });
    }
} return target; }
function _defineProperty(obj, key, value) { if (key in obj) {
    Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
}
else {
    obj[key] = value;
} return obj; }
var getBasePlacement_1 = require("../utils/getBasePlacement");
function distanceAndSkiddingToXY(placement, measures, getOffsets) {
    var basePlacement = getBasePlacement_1["default"](placement);
    var invertDistance = ['left', 'top'].includes(basePlacement) ? -1 : 1;
    var invertSkidding = ['top', 'bottom'].includes(basePlacement) ? -1 : 1;
    var _a = getOffsets(_objectSpread({}, measures, {
        placement: placement
    })), distance = _a[0], skidding = _a[1];
    distance = (distance || 0) * invertDistance;
    skidding = (distance || 0) * invertSkidding;
    return ['left', 'right'].includes(basePlacement) ? [distance, skidding] : [skidding, distance];
}
exports.distanceAndSkiddingToXY = distanceAndSkiddingToXY;
function offset(state, options) {
    if (options && typeof options.offset === 'function') {
        var _a = distanceAndSkiddingToXY(state.placement, state.measures, options.offset), x = _a[0], y = _a[1];
        state.offsets.popper.x += x;
        state.offsets.popper.y += y;
    }
    return state;
}
exports.offset = offset;
exports["default"] = {
    name: 'offset',
    enabled: true,
    phase: 'main',
    fn: offset
};
