"use strict";
exports.__esModule = true;
var getBasePlacement_1 = require("./getBasePlacement");
var getVariationPlacement_1 = require("./getVariationPlacement");
var getMainAxisFromPlacement_1 = require("./getMainAxisFromPlacement");
var getAltAxis_1 = require("./getAltAxis");
var enums_1 = require("../enums");
exports["default"] = (function (_a) {
    var reference = _a.reference, element = _a.element, strategy = _a.strategy, placement = _a.placement, scroll = _a.scroll;
    var basePlacement = placement ? getBasePlacement_1["default"](placement) : null;
    var variationPlacement = placement ? getVariationPlacement_1["default"](placement) : null;
    var scrollTop = scroll.scrollTop, scrollLeft = scroll.scrollLeft;
    var offsets;
    switch (basePlacement) {
        case enums_1.top:
            offsets = {
                x: reference.x + reference.width / 2 - element.width / 2 - scrollLeft,
                y: reference.y - element.height - scrollTop
            };
            break;
        case enums_1.bottom:
            offsets = {
                x: reference.x + reference.width / 2 - element.width / 2 - scrollLeft,
                y: reference.y + reference.height - scrollTop
            };
            break;
        case enums_1.right:
            offsets = {
                x: reference.x + reference.width - scrollLeft,
                y: reference.y + reference.height / 2 - element.height / 2 - scrollTop
            };
            break;
        case enums_1.left:
            offsets = {
                x: reference.x - element.width - scrollLeft,
                y: reference.y + reference.height / 2 - element.height / 2 - scrollTop
            };
            break;
        default:
            offsets = {
                x: reference.x - scrollLeft,
                y: reference.y - scrollTop
            };
    }
    var mainAxis = placement ? getMainAxisFromPlacement_1["default"](placement) : null;
    var altAxis = mainAxis ? getAltAxis_1["default"](mainAxis) : null;
    var len = altAxis === 'x' ? 'width' : 'height';
    var axis = [enums_1.right, enums_1.left].includes(basePlacement) ? mainAxis : altAxis;
    if (axis != null) {
        switch (variationPlacement) {
            case enums_1.start:
                offsets[axis] -= element[len] / 2;
                break;
            case enums_1.end:
                offsets[axis] += element[len] / 2;
                break;
            default:
        }
    }
    return offsets;
});
