"use strict";
exports.__esModule = true;
// source: https://stackoverflow.com/questions/49875255
var order = function (modifiers) {
    // indexed by name
    var mapped = modifiers.reduce(function (mem, i) {
        mem[i.name] = i;
        return mem;
    }, {}); // inherit all dependencies for a given name
    var inherited = function (i) {
        return mapped[i].requires ? mapped[i].requires.reduce(function (mem, i) {
            return mem.concat([i], inherited(i));
        }, []) : [];
    }; // order ...
    var ordered = modifiers.sort(function (a, b) {
        return !!~inherited(b.name).indexOf(a.name) ? -1 : 1;
    });
    return ordered;
};
exports["default"] = (function (modifiers) { return order(modifiers.filter(function (_a) {
    var phase = _a.phase;
    return phase === 'read';
})).concat(order(modifiers.filter(function (_a) {
    var phase = _a.phase;
    return phase === 'main';
})), order(modifiers.filter(function (_a) {
    var phase = _a.phase;
    return phase === 'afterMain';
})), order(modifiers.filter(function (_a) {
    var phase = _a.phase;
    return phase === 'write';
}))); });
